<?php
  class HTMLEngine{
      private $DB = null;
      private $LANGUAGE = array();
            
      public function __construct(){
          $this->DB = $GLOBALS['DB'];
          $this->LANGUAGE = $GLOBALS['LANGUAGE'];
          $this->SEO_URL = $GLOBALS['seo_url'];
      }
      
      /*********************** HTML HEAD ******************************/
      public function printHead($_contentId){
          $sql="SELECT * FROM meta";
          $meta = $this->DB->query($sql);
          
          $sql = "SELECT docTitle, docDesc, docKey, docClass FROM content WHERE id=$_contentId";
          $docMeta = $this->DB->query($sql);
          
          //SET THE CSS CLASS FOR THE INDIVIDUAL PAGE
          if (!empty($docMeta[0]['docClass'])){
              $GLOBALS['DOCCLASS'] = " id=\"".$docMeta[0]['docClass']."\"";
          }else{
              $GLOBALS['DOCCLASS'] = "";
          }
          
          //SET THE META DATA FOR THE INDIVIDUAL PAGE
          if(empty($docMeta[0]['docTitle'])){
              $docTitle = $meta[0]['meta_title'];
          }else{
              $docTitle = $docMeta[0]['docTitle'].'@'.$meta[0]['meta_title'];
          }
          if(empty($docMeta[0]['docDesc'])){
              $docDesc = $meta[0]['meta_desc'];
          }else{
              $docDesc = $docMeta[0]['docDesc'];
          }
          if(empty($docMeta[0]['docKey'])){
              $docKeywords = $meta[0]['meta_keywords'];
          }else{
              $docKeywords = $docMeta[0]['docKey'].','.$meta[0]['meta_keywords'];
          }
          
          echo ("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">".
                "<html>".
                "<head>".
                "<meta http-equiv=\"Expires\" content=\"".date(DATE_RSS)."\" />".
                "<meta http-equiv=\"Pragma\" content=\"no-cache\" />".
                "<meta http-equiv=\"Cache-Control\" content=\"no-cache\" />".
                "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />".
                "<meta http-equiv=\"Lang\" content=\"".$meta[0]['meta_lang']."\" />".
                "<meta name=\"author\" content=\"".$meta[0]['meta_author']."\" />".
                "<meta http-equiv=\"Reply-to\" content=\"".$meta[0]['meta_replyTo']."\" />".
                "<meta name=\"generator\" content=\"www.CMSQLite.net by www.Netzabdruck.de\" />".
                "<meta name=\"description\" content=\"".$docDesc."\" />".
                "<meta name=\"keywords\" content=\"".$docKeywords."\" />".
                "<meta name=\"creation-date\" content=\"02/01/2010\" />".
                "<meta name=\"revisit-after\" content=\"30 days\" />".
                "<title>".$docTitle."</title>");
                //Stylesheets and Javascripts
                
          echo ("<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"favicon.ico\">".
                "<link rel=\"stylesheet\" type=\"text/css\" href=\"system/css/system.css\" />".
                "<link rel=\"stylesheet\" type=\"text/css\" href=\"template/css/basic.css\" />".
                "<!--[if IE]><link rel=\"stylesheet\" href=\"template/css/basic_ie.css\" type=\"text/css\" media=\"screen\" /><![endif]-->".
                "<!--[if IE 6]><link rel=\"stylesheet\" href=\"template/css/basic_ie6.css\" type=\"text/css\" media=\"screen\" /><![endif]-->".
                "<script type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js\"></script>".
                "<script type=\"text/javascript\" src=\"js/basic-min.js\"></script>".
                "<script type=\"text/javascript\" src=\"system/lang/".$_SESSION['lang'].".js\"></script>");
      }
      
      /*********************** HTML FOOTER ******************************/
      public function printFoot(){
          $arrToReplace = array("\\\\\"","lt","gt");
          $arrReplace = array("'","<",">");
          $sql="SELECT gAnalytic FROM meta";
          $result = $this->DB->query($sql);
          echo ("<div id=\"cmsqliteFooter\"><span id=\"anchorFooter\"><a href=\"http://www.cmsqlite.net\" target=\"_blank\">powered by CMSQLite</a></span></div>".
          str_replace($arrToReplace,$arrReplace, $result[0]['gAnalytic']).
          "</body></html>");
      }
      
      /*********************** CONTENT ******************************/
      public function generateContent($_contentId, $_lngId, $_module){
          if($_contentId!=0){
              if ($_contentId==1){
                  $sql="SELECT * FROM content WHERE id=$_contentId AND langId='$_lngId' AND published=1";
                  $arrResult=$this->DB->query($sql);
                  if(empty($arrResult[0]['id'])){
                      $sql="SELECT * FROM content WHERE transOf=$_contentId AND langId='$_lngId' AND published=1";
                      $arrResult=$this->DB->query($sql);
                      if(empty($arrResult[0]['id'])){
                          $sql="SELECT * FROM content WHERE id=$_contentId AND langId='".DEFAULT_LANGUAGE."' AND published=1";
                          $arrResult=$this->DB->query($sql);
                          if(empty($arrResult[0]['id'])){
                              $sql="SELECT * FROM content WHERE id=1 AND langId='".DEFAULT_LANGUAGE."' AND published=1";
                              $arrResult=$this->DB->query($sql);
                          }
                      }
                  }
              }else{
                  $sql="SELECT * FROM content WHERE id=$_contentId AND published=1";
                  $arrResult=$this->DB->query($sql);
                  if(empty($arrResult[0]['id'])){
                      $sql="SELECT * FROM content WHERE transOf=$_contentId AND published=1";
                      $arrResult=$this->DB->query($sql);
                      if(empty($arrResult[0]['id'])){
                          $sql="SELECT * FROM content WHERE id=$_contentId AND langId='".DEFAULT_LANGUAGE."' AND published=1";
                          $arrResult=$this->DB->query($sql);
                          if(empty($arrResult[0]['id'])){
                              $sql="SELECT * FROM content WHERE id=1 AND langId='".DEFAULT_LANGUAGE."' AND published=1";
                              $arrResult=$this->DB->query($sql);
                          }
                      }
                  }
              }
          }
          /** REMOVE THE RAEDON HR FROM CONTENT**/
          $content = $this->removeReadon($arrResult[0]['content']);
          
          $re = "/\{{2}(mod_(\w)+)\}{2}/";
          
          $modTrue = preg_match_all($re,$content,$matches);
          
          if($modTrue != 0){
              $arrModules = array();
              $arrText = preg_split($re, $content);
              foreach($matches[1] as $match){
                  array_push($arrModules, $match);
              }
              for ($i=0;$i<=count($arrModules);$i++){
                  echo $arrText[$i];
                  $m = substr($arrModules[$i],strpos($arrModules[$i],'_')+1);
                  if (file_exists("modules/$m/".$arrModules[$i].".php")){
                      include ("modules/$m/".$arrModules[$i].".php");
                  }else{
                      echo "";
                  }
              }
              echo $arrText[++$i];
              
          }elseif(file_exists("modules/$_module/mod_".$_module.".php")){
              include "modules/$_module/mod_".$_module.".php";
          }else{
              if (!empty($content)){
                  echo ($content);
              }else{
                  include ("system/404.php");
              }
          }
      }
      
      /*********************** MENU ******************************/
      public function generateMenu($_langId, $_mnumodId, $_menuItem=NULL, $_full=TRUE){
          $sql="SELECT modName FROM menumodules WHERE id=$_mnumodId";
          $modName = $this->DB->query($sql);
          if (empty($modName[0]['modName'])){
              die("The menu module with the ID: $_mnumodId does not exist. Either create in the backend a new module or delete the call of the module from your template!");
          }
          $sql="SELECT * FROM menu WHERE langId='$_langId' AND mnumodId=$_mnumodId ORDER BY subLevel ASC, mnuOrder ASC";
          $menus = $this->DB->query($sql);
          
          if(empty($menus[0]['id'])){
              $this->generateMenu(DEFAULT_LANGUAGE, $_mnumodId);
          }
          echo ("<div id=\"".$modName[0]['modName']."listmenu\">");
          echo ("<ul class=\"".$modName[0]['modName']."Menu\">");
          
          for($z=0;$z<count($menus);$z++){
              if($menus[$z]['subLevel']==0){
                  
                  //CHECK IF ACTIVE ARTICLE IN MAIN MENU
                  if($menus[$z]['id']==$_menuItem){
                      $active=" active";
                  }else{
                      $active="";
                  }
                  if($menus[$z]['module']=='link'){
                      $active="";
                  }

                  //GET THE SUBMENU ITMES IF ANY
                  $arrSubmenu = array();
                  $makeSubmenu = false;
                  for ($i=0;$i<=count($menus);$i++){
                      if ($menus[$z]['id']==$menus[$i]['parent']){
                          array_push($arrSubmenu, array_slice($menus,$i,true));
                          if ($_menuItem == $menus[$i]['id']){
                              $makeSubmenu = true;
                          }
                      }
                      
                  }
                  
                  //SEO URL OR NOT FOR MAIN MENU ENTRY?
                  if ($this->SEO_URL){
                      if($menus[$z]['module']=='link'){
                          $link = $menus[$z]['link']; 
                      }else{
                          $link = "index.php?".$menus[$z]['mnuAlias'].".html";
                      }
                  }else{
                      $link = $menus[$z]['link'];
                  }
                                        
                  // ECHO MENU ITEM
                  if(!empty($arrSubmenu)){
                      echo ("<li class=\"".$modName[0]['modName']."MenuPoint parent".$active."\"><a href=\"".$link."\">".$menus[$z]['menutitle']."</a>");
                      
                      // IF FULL = TRUE THAN PRINT THE MENU WITH ALL THE SUBMENUS
                      if ($_full){
                          echo ("<ul class=\"".$modName[0]['modName']."SubMenu\">");
                          foreach($arrSubmenu as $submenu){
                              //SEO URL OR NOT FOR SUBMENU ITEM?
                              if ($this->SEO_URL){
                                  if($submenu[0]['module']=='link'){
                                      $link = $submenu[0]['link']; 
                                  }else{
                                      $link = "index.php?".$submenu[0]['mnuAlias'].".html";
                                  }
                              }else{
                                  $link = $submenu[0]['link'];
                              }
                              
                              //CHECK IF ACTIVE ARTICLE IN SUBMENU
                              if($submenu[0]['id']==$_menuItem){
                                  $active=" active";
                              }else{
                                  $active="";
                              }
                              if($submenu[0]['module']=='link'){
                                  $active="";
                              }
                              
                              //FINALLY ECHO THE ITEM
                              echo ("<li class=\"".$modName[0]['modName']."SubMenuPoint".$active."\"><a href=\"".$link."\">".$submenu[0]['menutitle']."</a></li>");
                          }
                          //CLOSE THE SUB LIST FROM THE SUBMENU
                          echo ("</ul>");
                      }else{
                          //IF ONE ONLY WANTS TO GENERATE THE SUBMENU WHEN RELEVANT
                          if ($menus[$z]['id']==$_menuItem XOR $makeSubmenu == true){
                              echo ("<ul class=\"".$modName[0]['modName']."SubMenu\">");
                                  foreach($arrSubmenu as $submenu){
                                      //SEO URL OR NOT FOR SUBMENU ITEM?
                                      if ($this->SEO_URL){
                                          if($submenu[0]['module']=='link'){
                                              $link = $submenu[0]['link']; 
                                          }else{
                                              $link = "index.php?".$submenu[0]['mnuAlias'].".html";
                                          }
                                      }else{
                                          $link = $submenu[0]['link'];
                                      }
                                      //CHECK IF ACTIVE ARTICLE IN SUBMENU
                                      if($submenu[0]['id']==$_menuItem){
                                          $active=" active";
                                      }else{
                                          $active="";
                                      }
                                      if($submenu[0]['module']=='link'){
                                          $active="";
                                      }
                                      //FINALLY ECHO THE ITEM
                                      echo ("<li class=\"".$modName[0]['modName']."SubMenuPoint".$active."\"><a href=\"".$link."\">".$submenu[0]['menutitle']."</a></li>");
                                  }
                              //CLOSE THE SUB LIST FROM THE SUBMENU
                              echo ("</ul>");
                         }
                      }
                      //CLOSE THE LIST ITEM FOR THE MAIN MENU POINT
                      echo ("</li>");
                  }else{
                      echo ("<li class=\"".$modName[0]['modName']."MenuPoint".$active."\"><a href=\"".$link."\">".$menus[$z]['menutitle']."</a></li>");
                  }
              }//End IF                  
          //End FOR
          }
        
          echo ("</ul>");
          echo ("</div>");
      }
      
      /*********************** INTEGRATE MODULE INTO PAGE ******************************/
      public function integrateModule($_module){
          if(file_exists(DOCUMENT_ROOT."/modules/$_module/mod_".$_module.".php")){
              include DOCUMENT_ROOT."/modules/$_module/mod_".$_module.".php";
          }
      }
      
      /*********************** HOVER FUNCTION FOR MENU JQUERY REQ. ******************************/
      public function JSMenuHover(){
          echo '$(".parent").mouseenter(function(){
              $(this).find("ul:first").css("display","block");
          });
          $(".parent").mouseleave(function(){
              $(this).find("ul:first").css("display","none")
          });
          $(".mainSubMenu").mouseleave(function(){
              $(this).css("display","none");
          });';
      }
      
      /*********************** READON FUNCTIONS ***********************************/
      public function removeReadon($_text){
          $content = str_replace('<hr class="readon" />',"",$_text);
          return $content;
      }
      
      public function insertReadon($_text, $_url){
          $pos = strpos($_text,'<hr class="readon" />');
          if ($pos===false){
              $content = substr($_text, 0);
          }else{
              $content = substr($_text, 0, $pos);
              $content = $content."<a class=\"readon\" href=\"".$_url."\">".$this->LANGUAGE['readon']."</a>";
          }
          return $content;
      }
      

  /****************************************************** ADMIN SECTION ***********************************************************/
      
      /*********************** ADMIN HTML HEAD ******************************/
      public function printAdminHead(){
          echo ("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">".
                "<html>".
                "<head>".
                "<meta http-equiv=\"Expires\" content=\"".date(DATE_RSS)."\" />".
                "<meta http-equiv=\"Pragma\" content=\"no-cache\" />".
                "<meta http-equiv=\"Cache-Control\" content=\"no-cache\" />".
                "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />".
                "<meta http-equiv=\"lang\" content=\"".$meta[0]['meta_lang']."\" />".
                "<meta name=\"author\" content=\"".$meta[0]['meta_author']."\" />".
                "<meta http-equiv=\"Reply-to\" content=\"".$meta[0]['meta_replyTo']."\" />".
                "<meta name=\"generator\" content=\"www.CMSQLite.net by www.Netzabdruck.de\" />".
                "<meta name=\"description\" content=\"".$meta[0]['meta_desc']."\" />".
                "<meta name=\"keywords\" content=\"".$meta[0]['meta_keywords']."\" />".
                "<meta name=\"creation-date\" content=\"10/01/2009\" />".
                "<meta name=\"revisit-after\" content=\"30 days\" />".
                "<title>".$meta[0]['meta_title']."</title>");
                //Stylesheets and Javascripts
                
          echo ("<link rel=\"stylesheet\" type=\"text/css\" href=\"".HTTP_ROOT."/admin/css/adminBasic.css\" />".
                "<!--[if IE 6]><link rel=\"stylesheet\" href=\"".HTTP_ROOT."/admin/css/adminBasic_ie6.css\" type=\"text/css\" media=\"screen\" /><![endif]-->".
                "<!--[if IE]><link rel=\"stylesheet\" href=\"".HTTP_ROOT."/admin/css/adminBasic_ie.css\" type=\"text/css\" media=\"screen\" /><![endif]-->".
                "<script type=\"text/javascript\" src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js\"></script>".
                "<script type=\"text/javascript\" src=\"".HTTP_ROOT."/system/lang/".$_SESSION['lang'].".js\"></script>".
                "<script type=\"text/javascript\" src=\"".HTTP_ROOT."/admin/js/admin-min.js\"></script>");
      }
            
      /*********************** ADMIN MENU ******************************/
      public function generateAdminMenu($_helpLang, $_anchor=NULL){
          $sql="SELECT * FROM menumodules";
          $menuModules = $this->DB->query($sql);
          echo "<div id=\"adminNavi\">".
                "<ul class=\"adminMenu\">".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_articles'].
                    "<ul class=\"adminSubmenu\">".
                        "<li class=\"adminSubmenuPoint\"><a href=\"overview.php\">".$this->LANGUAGE['mnu_home']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"createArticle.php\">".$this->LANGUAGE['mnu_new']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"createCategorie.php\">".$this->LANGUAGE['mnu_cat']."</a></li>".
                    "</ul>".
                "</li>".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_menu'].
                    "<ul class=\"adminSubmenu\">";
                        foreach ($menuModules as $menuMod){
                            echo "<li class=\"adminSubmenuPoint\"><a href=\"editMenu.php?id=".$menuMod['id']."&langId=".DEFAULT_LANGUAGE."\">".$menuMod['modDescription']."</a></li>";
                        }
                echo "</ul>".
                "</li>".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_media'].
                    "<ul class=\"adminSubmenu\">".
                        "<li class=\"adminSubmenuPoint\"><a href=\"mediaAdmin.php\">".$this->LANGUAGE['mnu_browser']."</a></li>".
                    "</ul>".
                "</li>".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_modules'].
                    "<ul class=\"adminSubmenu\">".
                        "<li class=\"adminSubmenuPoint\"><a href=\"createMenuModule.php\">".$this->LANGUAGE['mnu_menumodule']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"createPageModule.php\">".$this->LANGUAGE['mnu_pagemodule']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"createContentModule.php\">".$this->LANGUAGE['mnu_contentmodule']."</a></li>".
                    "</ul>".
                "</li>".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_option'].
                    "<ul class=\"adminSubmenu\">".
                        "<li class=\"adminSubmenuPoint\"><a href=\"editConfiguration.php\">".$this->LANGUAGE['mnu_system']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"overviewUsers.php\">".$this->LANGUAGE['users']."</a></li>".
                    "</ul>".
                "</li>".
                "<li class=\"adminMenuPoint parent\">".$this->LANGUAGE['mnu_help'].
                    "<ul class=\"adminSubmenu\">".
                        "<li class=\"adminSubmenuPoint\"><a href=\"javascript:popupWin('"."help/1".$_helpLang.".html".$_anchor."')\">".$this->LANGUAGE['mnu_help']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"http://www.cmsqlite.net\" target=\"_blank\">".$this->LANGUAGE['mnu_visitCMSQLite']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"javascript:checkForUpdates('".VERSION."')\">".$this->LANGUAGE['mnu_update']."</a></li>".
                        "<li class=\"adminSubmenuPoint\"><a href=\"javascript:showDialog('".VERSION."')\">".$this->LANGUAGE['mnu_about']."</a></li>".
                    "</ul>".
                "</li>".
                "</ul>".
                "</div>";
          echo "<div id=\"picNavi\">".
               "<ul>".
                   "<li class=\"\"><a href=\"javascript:popupWin('".HTTP_ROOT."')\"><img src=\"../system/img/preview.png\" border=\"0\" width=\"18\" height=\"18\" alt=\"Preview\" title=\"".$LANGUAGE['tip_preview_page']."\"></a></li>
                    <li class=\"\"><a href=\"javascript:popupWin('help/1".$_helpLang.".html')\"><img src=\"../system/img/iconhelp.png\" border=\"0\" width=\"18\" height=\"18\" alt=\"Help\" title=\"".$LANGUAGE['mnu_help']."\"></a></li>
                    <li class=\"\"><a href=\"javascript:logoff();\"><img src=\"../system/img/exit.png\" border=\"0\" width=\"25\" height=\"18\" alt=\"Logout\" title=\"".$LANGUAGE['mnu_logout']."\"></a><a href=\"javascript:logoff();\">Logout</a></li>".
                "</ul>".
                "</div>";
      }
      
      /*********************** ADMIN HTML FOOTER ******************************/
      public function printAdminFoot(){
          echo "<div id=\"dialog\"></div>".
                "</body>".
                "</html>";
      }
  
  /****************************************************** ADMIN SECTION ***********************************************************/
  }
?>