<?php
//CHECK ALL PREFERENCES NECESSARY TO RUN CMSQLITE
if(file_exists(DOCUMENT_ROOT."/settings.php")){
    header("location:".HTTP_ROOT."/system/fail2.html");
    exit;
}
$errSqliteExtension = true;
if (!extension_loaded('sqlite')){
   $errSqliteExtension = false; 
}
$arrVersion = explode('.', phpversion());
$phpVersion = $arrVersion[0] * 1000 + $arrVersion[1] * 100 + $arrVersion[2];
$errPHPVersion = true;
if($phpVersion < 5000 XOR $phpVersion >5300){
    $errPHPVersion = false;
}
//DEFINE THE PATH SETTINGS FOR THE SCRIPT AND GATHER ALL NECESSARY SCRIPTS
$script=$_SERVER['PHP_SELF'];
$subfolder=substr($script,0,strrpos($script,"/"));
define('PROJECT',$subfolder);
define('DOCUMENT_ROOT',$_SERVER['DOCUMENT_ROOT'].PROJECT);
define('DB_Name','cmsqlite.db');

require "class/includeAllClasses.php";

$DB = new Database();
$USER = new User();
$HTML = new HTMLEngine();

$arrayLanguages = array("de","en","sv");

  session_start();
  
  //SET LANGUAGE
  $lang = $USER->getLanguage();
  if(in_array($lang, $arrayLanguages)){
      $_SESSION['lang']=$lang;
  }else{
      $_SESSION['lang']="en";
  }
    
  include DOCUMENT_ROOT."/system/lang/".$_SESSION['lang'].".php";
  $LANGUAGE = json_decode($lang, TRUE);
  
  //Set the variables for the form
  $domain = "www.cmsqlite.net";
  $title = "CMSQlite - SQLite Content Management System";
  $email = "info@cmsqlite.net";
  $description = "CMSQlite, kostenloses SQLite Content Management System";
  $keywords = "content management system, sqlite, CMSQLite, kostenloses SQLite CMS";
  $author = "CMSQLite";
    
  if(isset($_POST['submit'])){
      $arrErrors = array();
      $domain=$_POST['domain'];
      $title=$_POST['title'];
      $email=$_POST['email'];
      $pwd1=$_POST['password1'];
      $pwd2=$_POST['password2'];
      $lang=$_POST['lang'];
      $description=$_POST['description'];
      $keywords=$_POST['keywords'];
      $author=$_POST['author'];
      $seo_url= $_POST['rad_seo'];
      
      if($pwd1!=$pwd2){
          die($LANGUAGE['pwd_not_equal']);
      }
      $domain=strtolower($domain);
      $pattern="/^w{3}.\w+.\w{2,4}(\/\w+)?|\w+.\w+.\w{2,4}(\/\w+)?|localhost(\/\w+)?$/";
      if(!preg_match($pattern,$domain)){
          die($LANGUAGE['domain_wrong']);
      }
      
      //Datei erstellen, öffnen und schreiben:
      if(file_exists(DOCUMENT_ROOT."/settings.php")){
          die($LANGUAGE['setting_file_exists']);
      }else{
          $filecontent='<?php
            define (\'DB_Name\',\'cmsqlite.db\');
            define(\'DEFAULT_LANGUAGE\',\''.$lang.'\');
            define (\'STARTPAGE\',\''.$domain.'\');
            define (\'MYMAIL\',\''.$email.'\');
            define (\'TOKEN\',\''.$USER->createToken().'\');
            $arrayLanguages = array(\'de\', \'en\', \'sv\');
            $seo_url=\''.$seo_url.'\';
            ?>';
          //Filehandler
          if (!$handler=fopen(DOCUMENT_ROOT."/settings.php","w")){
              echo ($LANGUAGE['file_not_writeable'].'<p><code>&lt;?php<br />define (\'DB_Name\',\'cmsqlite.db\');<br />define(\'DEFAULT_LANGUAGE\',\''.$lang.'\');<br />define (\'STARTPAGE\',\''.$domain.'\');<br />define (\'MYMAIL\',\''.$mail.'\');<br />$arrayLanguages = array(\'de\', \'en\');<br />?&gt;</code></p>');
                  die();
          }else{
              
              //.htaccess umbennen
              if (file_exists(DOCUMENT_ROOT."/data/htaccess.txt")){
                  if(!rename(DOCUMENT_ROOT."/data/htaccess.txt",DOCUMENT_ROOT."/data/.htaccess")){
                      die($LANGUAGE['htaccess_file_error']);
                  }
              }else{
                  array_push($arrErrors,$LANGUAGE['htacessfile_missing']);
              }
              
              //Write text to settings file
              if (fwrite($handler,$filecontent)===FALSE){
                  echo ($LANGUAGE['file_not_writeable'].'<p><code>&lt;?php<br />define (\'DB_Name\',\'cmsqlite.db\');<br />define(\'DEFAULT_LANGUAGE\',\''.$lang.'\');<br />define (\'STARTPAGE\',\''.$domain.'\');<br />define (\'MYMAIL\',\''.$mail.'\');<br />$arrayLanguages = array(\'de\', \'en\');<br />$seo_rul=\'0\'<br />?&gt;</code></p>');
                  die();
              }else{            
                  //Daten in Datenbank schreiben
                  $md5pwd=MD5($pwd1);
                  $sql="INSERT INTO meta VALUES(NULL,'$lang','$email','$description','$keywords','$title','$author','');INSERT INTO login VALUES (NULL,1,'admin','$md5pwd');";
                  $result=$DB->queryEx($sql);
                  if($result){
                      foreach ($arrErrors as $error){
                          echo $error."<br />";
                      }
                      echo $LANGUAGE['install_finished']."<br /><input type=\"button\" value=\"".$LANGUAGE['button_next']."\" onclick=\"window.location.href='index.php'\" />";
                  }else{
                      echo $LANGUAGE['error_writing_db'];
                  }
              }
          }
      }     
      
  }else{      
      $permData=substr(sprintf('%o', fileperms('data')), -4);
      $permDatabase=substr(sprintf('%o', fileperms('data/cmsqlite.db')), -4);
      $permMedia=substr(sprintf('%o', fileperms('media')), -4);
      
      $HTML->printHead(0);
?>
<link rel="stylesheet" type="text/css" href="admin/css/adminBasic.css" />
</head>
<body>
<div class="overviewWrapper">
      <div class="systemHeader"><h2 class="systemHeadlines"><?php echo $LANGUAGE['headline_install']; ?></h2></div>
      <div class="contentOverview">
<noscript><h2><?php echo $LANGUAGE['noscript'] ?></h2></noscript>
        <div>
            <?php
                if(!empty($subfolder)){
                    echo ("<div id=\"subfolder_warning\">".$LANGUAGE['install_subfolder']."</div>");
                }
            ?>
        </div>
        <div class="contentInstall">
        <form id="frm_install" name="frm_install" action="install.php" method="post" onsubmit="return checkForm('frm_install')">
            <fieldset>
            <legend><?php echo $LANGUAGE['inst_page_legend'] ?></legend>
            <table><tbody>
                <?php
                    $disableButton="";
                    if($errSqliteExtension){
                       echo ("<tr><td class=\"fpermTrue\">".$LANGUAGE['ok_sqlite_extension']."</td></tr>");
                    }else{
                       echo ("<tr><td class=\"fpermFalse\">".$LANGUAGE['err_sqlite_extension']."</td></tr>");
                       $disableButton="disabled=\"true\"";  
                    }
                    if($errPHPVersion){
                       echo ("<tr><td class=\"fpermTrue\">".$LANGUAGE['ok_php_version']."</td></tr>");
                    }else{
                       echo ("<tr><td class=\"fpermFalse\">".$LANGUAGE['err_php_version']."</td></tr>");
                       $disableButton="disabled=\"true\"";  
                    }
                    if($permData=="0777"){
                        echo ("<tr><td class=\"fpermTrue\">".$LANGUAGE['data_writable']."</td></tr>");
                    }else{
                        echo ("<tr><td class=\"fpermFalse\">".$LANGUAGE['data_not_writable']."</td></tr>");
                        $disableButton="disabled=\"true\"";
                    }
                    if($permDatabase=="0666" xor $permDatabase=="0766" xor $permDatabase=="0777"){
                        echo ("<tr><td class=\"fpermTrue\">".$LANGUAGE['database_writable']."</td></tr>");
                    }else{
                        echo ("<tr><td class=\"fpermFalse\">".$LANGUAGE['database_not_writable']."</td></tr>");
                        $disableButton="disabled=\"true\"";
                    }
                    if($permMedia=="0777"){
                        echo ("<tr><td class=\"fpermTrue\">".$LANGUAGE['media_writable']."</td></tr>");
                    }else{
                        echo ("<tr><td class=\"fpermFalse\">".$LANGUAGE['media_not_writable']."</td></tr>");
                        $disableButton="disabled=\"true\"";
                    }
                    if($disableButton!=""){
                        echo("<tr><td class=\"fpermExpl\">".$LANGUAGE['install_filemod_explanation']."</td></tr>");
                    }                    
                ?>
            </tbody></table>
        
            <table><tbody>        
            <tr>
            <td class="td_meta_desc"><label for="txtDomain"><?php echo $LANGUAGE['inst_page_domain'] ?>:</label></td><td><input id="txtDomain" type="text" name="domain" maxlength="50" size="50" required="1" onblur="checkField(this)" value="<?php echo $domain ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtTitle"><?php echo $LANGUAGE['meta_title'] ?>:</label></td><td><input id="txtTitle" type="text" name="title" maxlength="100" size="50" required="1" onblur="checkField(this)" value="<?php echo $title ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtEmail"><?php echo $LANGUAGE['inst_page_email'] ?>:</label></td><td><input id="txtEmail" type="text" name="email" maxlength="50" size="50" required="1" onblur="checkMail(this)" value="<?php echo $email ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtPwd1"><?php echo $LANGUAGE['inst_page_password1'] ?>:</label></td><td><input id="txtPwd1" type="password" name="password1" maxlength="8" size="50" required="1" onblur="checkField(this)" value="" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtPwd2"><?php echo $LANGUAGE['inst_page_password2'] ?>:</label></td><td><input id="txtPwd2" type="password" name="password2" maxlength="8" size="50" required="1" onblur="checkPassword()" value="" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="selLang"><?php echo $LANGUAGE['inst_page_language'] ?>:</label></td>
                <td><select id="selLang" name="lang">
                    <option value="de">de</option>
                    <option value="en">en</option>
                    </select>
                </td>
            </tr>
            
            <tr><td colspan="2" style="padding:8 0 0 0;"><span style="font-weight:bold; font-size: .8em;"><?php echo $LANGUAGE['config_legend'] ?></span></td></tr>
            <tr>
            <td class="td_meta_desc"><label for="txtDesc"><?php echo $LANGUAGE['meta_desc'] ?>:</label></td><td><input id="txtDesc" type="text" name="description" maxlength="500" size="50" required="1" onblur="checkField(this)" value="<?php echo $description ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtKey"><?php echo $LANGUAGE['meta_keywords'] ?>:</label></td><td><input id="txtKey" type="text" name="keywords" maxlength="500" size="50" required="1" onblur="checkField(this)" value="<?php echo $keywords ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><label for="txtAuthor"><?php echo $LANGUAGE['meta_author'] ?>:</label></td>
            <td><input id="txtAuthor" type="text" name="author" maxlength="100" size="50" required="1" onblur="checkField(this)" value="<?php echo $author ?>" /><span class="frm_error_msg"></span></td>
            </tr>
            <tr>
            <td class="td_meta_desc"><?php echo $LANGUAGE['inst_seo_url'] ?>:</td>
            <td>
                <input id="rad_seoYes" type="radio" name="rad_seo" value="1" /> <span style="font-size: .8em;"><?php echo $LANGUAGE['yes'] ?></span>
                <input id="rad_seoNo" type="radio" name="rad_seo" value="0" checked="checked" /><span style="font-size: .8em;"><?php echo $LANGUAGE['no'] ?></span>
            </td>
            </tr>        
            <tr>
            <td colspan="2">
                <input type="submit" value="<?php echo $LANGUAGE['button_install'] ?>" name="submit" <?php echo $disableButton ?> />
                <input type="reset" value="<?php echo $LANGUAGE['button_esc'] ?>" name="reset" />
            </td>
            </tr>
            </tbody></table>
            </fieldset>
        </form>
        </div>

      </div>
</div>
</body>
</html>
<?php
  }
?>

